return {
  {
    name = "0.0.1",
    text = WMP.important_text("* ").."Initial release - exact date no longer known, but no later than June 15th, 2010"
  },
  {
    name = "3.8.0",
    text = WMP.important_text("* ").."Fixed macro includes."
..WMP.important_text("\n* ").."Upgrade option/message to DescriptionWML."
..WMP.important_text("\n* ").."Fixed/removed formulas."
..WMP.important_text("\n* ").."MusicMacros namespace added."
..WMP.important_text("\n* ").."Modify playlist functionality: remove songs generated list not updating correctly after song removal."
  },
  {
    name = "3.8.2",
    text = WMP.important_text("* ").."Changelog option under info."
..WMP.important_text("\n* ").."Check that generated lists are alphabetized a-z - typed song history/need an additional key to keep track of the order they were inserted so the songs lowest in the alphabet aren't the only ones dropped."
..WMP.important_text("\n* ").."Change label column to description column for DescriptionWML."
..WMP.important_text("\n* ").."OPTION_NOTHING check for empty string before clearing so it can be used everywhere."
..WMP.important_text("\n* ").."Update list of portraits."
..WMP.important_text("\n* ").."Make sure all OPTION_ATTRIBUTES calls by default have the text in the description key."
  },
  {
    name = "3.8.5",
    text = WMP.important_text("* ").."Split up macros/lua into semantic files"
..WMP.important_text("\n* ").."Move non-macros into new 'options' directory"
..WMP.important_text("\n* ").."Have CHANGELOG_ENTRY automatically insert asterisks after a newline"
..WMP.important_text("\n* ").."Fixed infinite loop in creating a temporary playlist"
..WMP.important_text("\n* ").."Added macro re-definition warnings, only works for things loaded before Music"
..WMP.important_text("\n* ").."Logging macro - append to MusicDebug namespace and write to file."
..WMP.important_text("\n* ").."Replace #ifhave with show_if/have_file"
..WMP.important_text("\n* ").."Toggle playlist shuffling (default yes)"
  },
  {
    name = "3.8.6",
    text = WMP.important_text("* ").."MusicPersist.version - update per release and use for compatibility checking"
..WMP.important_text("\n* ").."VERSION_CHECK to simplify checking the version"
  },
  {
    name = "3.9.0",
    text = WMP.important_text("* ").."Split off events into separate folder"
..WMP.important_text("\n* ").."Split off compatibility upgrades into separate file"
..WMP.important_text("\n* ").."Split off first time setup into separate file"
..WMP.important_text("\n* ").."Create new map, still single player but a nicer aesthetic"
..WMP.important_text("\n* ").."Use default variable syntax for first time setup rather than if/then statements"
..WMP.important_text("\n* ").."Remove blank.ogg from playlists, no longer necessary with shuffle key though first played song not random, bug report filed"
..WMP.important_text("\n* ").."Fixed song ordering in MusicPerist.playlists - was ordered z>a rather than a>z"
..WMP.important_text("\n* ").."Showing songs in a playlist now goes back to list of playlists rather than Modify Playlists menu when done"
..WMP.important_text("\n* ").."Fixed and rewrote removing songs from a playlist option"
  },
  {
    name = "3.9.3",
    text = WMP.important_text("* ").."Add support for frantic-old"
..WMP.important_text("\n* ").."Replace FOREACH_SUBSET/WHILE_NEXT macros with [for]"
..WMP.important_text("\n* ").."replace BREAK definition with [break] tags"
..WMP.important_text("\n* ").."Fixed infinite loop when creating temporary playlist"
..WMP.important_text("\n* ").."Replace NEW_VAR_OP with formula - original problem was that it was trying to evaluate a formula with a variable that didn't exist yet due to an engine bug"
..WMP.important_text("\n* ").."Put numbers on generated lists in the label field"
  },
  {
    name = "3.9.5",
    text = WMP.important_text("* ").."Removed MusicPersist.playlist_names, same info is stored in MusicPersist.playlists[].description"
..WMP.important_text("\n* ").."Upgrade ALPHABETIZE_PLAYLISTS to sort any list by any attribute"
  },
  {
    name = "3.9.6",
    text = WMP.important_text("* ").."Fixed the list of songs in a playlist not being populated after a song to play was chosen"
  },
  {
    name = "3.9.7",
    text = WMP.important_text("* ").."Adjusted path to portraits after non-transparent portraits were removed"
  },
  {
    name = "3.9.8",
    text = WMP.important_text("* ").."Added custom objective"
..WMP.important_text("\n* ").."The color of normal text in messages can be changed from white"
..WMP.important_text("\n* ").."Important text can be set to white"
..WMP.important_text("\n* ").."Text color can be set to a hex value"
..WMP.important_text("\n* ").."Add option to have no message image"
..WMP.important_text("\n* ").."The current playlist is colored as important text"
..WMP.important_text("\n* ").."OPTION_NOTHING options are set as the default option"
..WMP.important_text("\n* ").."Removed empty dummy option from MusicPersist.typed_history"
  },
  {
    name = "3.9.9",
    text = WMP.important_text("* ").."Replaced [message] attributes with MSG_ATTRIBUTES macro"
..WMP.important_text("\n* ").."Added message configuration options for: font, font_size, font_style, font_weight"
..WMP.important_text("\n* ").."Merged [compare_ignore_case] with other string comparison tags and renamed the tag to [string_compare]"
..WMP.important_text("\n* ").."Playlist and typed songs sorting is now case insensitive"
..WMP.important_text("\n* ").."The ALPHABETIZE_LIST macro is now used for sorting the list of typed songs"
..WMP.important_text("\n* ").."Fixed error message not appearing when a non-existent song name was typed"
..WMP.important_text("\n* ").."Songs selected from List of Songs in Playlist are now added to Typed Song History"
..WMP.important_text("\n* ").."Renamed Typed Song History to Song History"
  },
  {
    name = "4.0.0",
    text = WMP.important_text("* ").."Both left and right portraits can now be specified on the [message]"
..WMP.important_text("\n* ").."Added workaround for bug #25186"
..WMP.important_text("\n* ").."Fixed Song History keeping one song too many around"
..WMP.important_text("\n* ").."Added ImagePathFunctions which can be added and removed from the right or left portrait"
..WMP.important_text("\n* ").."Fixed upgrade logic causing improperly initialized variables when no data existed to upgrade"
..WMP.important_text("\n* ").."Value of file name verification is now colored as important text"
  },
  {
    name = "4.0.1",
    text = WMP.important_text("* ").."Allow editing existing ImagePathFunctions"
..WMP.important_text("\n* ").."Allow manually entering the entire text of an ImagePathFunction"
  },
  {
    name = "4.0.2",
    text = WMP.important_text("* ").."Typed History size no longer allows an empty value"
..WMP.important_text("\n* ").."The current Typed History size and its default are displayed when entering a new size"
..WMP.important_text("\n* ").."Replaced FOREACH macro with [for] - FOREACH is deprecated"
..WMP.important_text("\n* ").."Current Playlist shows as N/A when there is no current playlist"
..WMP.important_text("\n* ").."Removed upgrade path from versions that don't have WML version information"
  },
  {
    name = "4.0.3",
    text = WMP.important_text("* ").."Added the maps: Cave, CaveSkirmish, TheHallway - from an old map pack of mine"
..WMP.important_text("\n* ").."Added option to remove specific songs from the song history"
..WMP.important_text("\n* ").."Setting the history size to -1 removes the history limit"
..WMP.important_text("\n* ").."Extra songs are now removed when the song history limit is decreased"
  },
  {
    name = "4.0.4",
    text = WMP.important_text("* ").."It is now possible to create a temporary playlist from multiple permanent playlists"
..WMP.important_text("\n* ").."Fixed renaming a playlist not working at all"
..WMP.important_text("\n* ").."Fixed renaming a playlist not updating the playlist label number"
..WMP.important_text("\n* ").."Fixed mirroring the left image sometimes not working"
  },
  {
    name = "4.0.5",
    text = WMP.important_text("* ").."Removed all use of 'true' and 'false' values, since lua converts them to 'yes' and 'no'"
..WMP.important_text("\n* ").."Rewrote all conditionals to use the correct data types for clarity"
  },
  {
    name = "4.0.6",
    text = WMP.important_text("* ").."Removed IPFs ~DARKEN() and ~LIGHTEN()"
..WMP.important_text("\n* ").."Added IPF ~NOP()"
..WMP.important_text("\n* ").."Added basic scenario files for the recently added maps"
..WMP.important_text("\n* ").."Finally fixed the original map to make it always start at night"
..WMP.important_text("\n* ").."Re-implemented much simpler workaround for bug #24231"
  },
  {
    name = "4.1.0",
    text = WMP.important_text("* ").."The text Current Playlist when choosing a new playlist to play is now important text"
..WMP.important_text("\n* ").."Fixed choosing the Play Playlist option and then choosing Nothing reseting the current playlist"
..WMP.important_text("\n* ").."Fixed a lua error when choosing the Play Playlist option and then choosing Nothing reseting the current playlist"
..WMP.important_text("\n* ").."Fixed typing an existing song creating an empty entry in the song history"
..WMP.important_text("\n* ").."Fixed the Delete Playlist list only showing odd entries"
..WMP.important_text("\n* ").."[string_compare] no longer cares whether the comparator is an empty string or not"
..WMP.important_text("\n* ").."Fixed choosing a song for a temporary playlist popping back up to the list of playlists"
..WMP.important_text("\n* ").."Simplified the logic for adding songs to a temporary or a permanent playlist"
..WMP.important_text("\n* ").."Songs chosen when creating a temporary playlist no longer reappear if Nothing is selected, and then the same playlist is selected a second time"
..WMP.important_text("\n* ").."Set the default=no attribute on all permanent playlists"
  },
  {
    name = "4.1.1",
    text = WMP.important_text("* ").."The currently playing song is displayed with an option"
..WMP.important_text("\n* ").."Clean up persistent variables/macros"
..WMP.important_text("\n* ").."Fixed removing a song from the history not updating the label numbering"
..WMP.important_text("\n* ").."Use wesnoth.music_list.next() instead of blank.ogg for forcing the first song of a playlist to be randomized"
..WMP.important_text("\n* ").."Removed option to stop playlist the current playlist"
..WMP.important_text("\n* ").."Removed blank.ogg"
..WMP.important_text("\n* ").."Fixed the first song played after adding a song to the current playlist not being randomized"
..WMP.important_text("\n* ").."Unmuting now sets the the volume back to what it was when it was muted"
..WMP.important_text("\n* ").."Added new option to play the next song in the playlist"
  },
  {
    name = "4.1.2",
    text = WMP.important_text("* ").."ALPHABETIZE_LIST no longer checks for incorrectly create empty indexes - this bug has been fixed"
..WMP.important_text("\n* ").."Allow [string_compare] to compare two string literals"
..WMP.important_text("\n* ").."Created macro ALPHABETIZE_WHOLE_LIST - uses ALPHABETIZE_LIST to insertion sort an entire list"
..WMP.important_text("\n* ").."Song history option now displays how it is sorted"
  },
  {
    name = "4.1.5",
    text = WMP.important_text("* ").."Renamed ALPHABETIZE_LIST to SORT_FIRST_ELEMENT"
..WMP.important_text("\n* ").."Renamed ALPHABETIZE_WHOLE_LIST to SORT_ALL_ELEMENTS"
..WMP.important_text("\n* ").."Improved SORT_FIRST_ELEMENT efficiency"
..WMP.important_text("\n* ").."Made the STR_* macros' CASE argument optional, defaults to yes"
..WMP.important_text("\n* ").."Removed a previously missed reference to blank.ogg"
..WMP.important_text("\n* ").."Fixed song history age not getting correctly decremented when removing a song"
..WMP.important_text("\n* ").."Moved song history options to be directly under Modifications"
..WMP.important_text("\n* ").."Ported SORT_FIRST_ELEMENT to a lua-implemented WML tag"
..WMP.important_text("\n* ").."Removed unused debugging code"
..WMP.important_text("\n* ").."Changed clearing the whole MusicMacros namespace at the end of some macros to clearing only the specific variables used"
  },
  {
    name = "4.2.0",
    text = WMP.important_text("* ").."Removed unused Help option"
..WMP.important_text("\n* ").."NULL_EQ and NULL_NE macros now use [check_null] tag to compare the WML variable value to lua nil rather than comparing to MusicTemp.null."
..WMP.important_text("\n* ").."Moved the option to play the next song in the playlist under Current And Previous Songs"
..WMP.important_text("\n* ").."Added an option to restart the current song"
..WMP.important_text("\n* ").."Added an option to add the current song to the song history"
..WMP.important_text("\n* ").."Added an option to play the previous song"
..WMP.important_text("\n* ").."Added an option to add the previous song to the song history"
..WMP.important_text("\n* ").."Added options to sort song history ascending or descending"
..WMP.important_text("\n* ").."Added options to sort sort permanent playlists ascending or descending"
  },
  {
    name = "4.2.2",
    text = WMP.important_text("* ").."Resort temporary playlists along with permanent playlists"
..WMP.important_text("\n* ").."Display sort by and sort order in Play a Playlist and Song History messages"
..WMP.important_text("\n* ").."Changed menu id to wesnoth_music_player and renamed add-on to Wesnoth Music Player"
..WMP.important_text("\n* ").."Give each macro into its own file so I don't have to guess where they are anymore"
..WMP.important_text("\n* ").."Reworked how the message loops function so they manage themselves without me have to specify a loop variable in most cases"
..WMP.important_text("\n* ").."Fixed numbering being wrong for creating temporary playlists when choosing some songs from a playlist, going back up to the list of playlists, then back to the same playlist"
..WMP.important_text("\n* ").."IPFs and left/right images are now set at the playlist level"
..WMP.important_text("\n* ").."Added starts_with, ends_with, and contains keys to [string_compare]"
..WMP.important_text("\n* ").."Fixed ~FL() IPF incorrectly being ~FLIP()"
  },
  {
    name = "4.3.0",
    text = WMP.important_text("* ").."Replaced numerical comparisons using [variable] with [number_compare]"
..WMP.important_text("\n* ").."Replaced boolean comparisons using [variable] with [boolean_compare]"
..WMP.important_text("\n* ").."Renamed [check_null] to [null_compare]"
..WMP.important_text("\n* ").."Fixed direct call to string_compare() function is lua still using name attribute"
..WMP.important_text("\n* ").."Removed missed reference to MusicTemp.repeating* variable"
..WMP.important_text("\n* ").."Changed [text_input] loops to exit when given an empty string rather than \"end\" or \"end.ogg\""
..WMP.important_text("\n* ").."Fixed infinite option loop when choosing songs to play from a playlist"
..WMP.important_text("\n* ").."Fixed [string_compare] error when a song already in the history is sent to ADD_TO_SONG_HISTORY"
..WMP.important_text("\n* ").."Added help text for options that do anything particularly complex or interesting"
..WMP.important_text("\n* ").."Added an option to allow setting the color of options for which help text is enabled"
..WMP.important_text("\n* ").."Added a new Data Management option to validate if there are any songs in any playlists that no longer exist"
..WMP.important_text("\n* ").."Fixed the playlist name of a newly created playlist overwriting the Current Playlist name of all playlists"
..WMP.important_text("\n* ").."[sort_single_element] now has an optional argument of RETURN, which specifies a variable to store the index where the newly sorted element was inserted"
..WMP.important_text("\n* ").."Fixed saving temporary playlists being broken in multiple ways"
  },
  {
    name = "4.3.1",
    text = WMP.important_text("* ").."Added additional checks for correctness in lua-implemented tags"
..WMP.important_text("\n* ").."Removed MusicSession.muted variable"
..WMP.important_text("\n* ").."Removed setting the volume to what it was before it was muted"
..WMP.important_text("\n* ").."Allow hiding/showing mainline songs"
..WMP.important_text("\n* ").."Fixed enabling the help option text changing the option color, but not enabling the text"
..WMP.important_text("\n* ").."Added option to change the option text color"
  },
  {
    name = "4.5.0",
    text = WMP.important_text("* ").."Overhauled almost everything"
..WMP.important_text("\n* ").."Added an option to reload data since the last save"
..WMP.important_text("\n* ").."Only the name of the current playlist is colored as important text, instead of the entire message"
..WMP.important_text("\n* ").."Reorganized MusicPersist.playlists data structure"
..WMP.important_text("\n* ").."Moved largest macros into lua"
..WMP.important_text("\n* ").."Moved all but one metavars into metadata"
..WMP.important_text("\n* ").."The sorting and ordering type is not colored as important text"
..WMP.important_text("\n* ").."The current playlist name is now displayed when changing its message images and IPFs"
..WMP.important_text("\n* ").."Fixed tons of bugs"
..WMP.important_text("\n* ").."Split lua files into separate files per tag"
..WMP.important_text("\n* ").."Added a check to prevent modifying a different version of persistent data than the version of the WML in a save file"
..WMP.important_text("\n* ").."The mainline and UMC music options are now generated from MusicSession.wesnoth_songs"
..WMP.important_text("\n* ").."MusicSession.current_playlist is now under MusicPersist"
..WMP.important_text("\n* ").."Added a new mainline song: return_to_wesnoth.ogg"
..WMP.important_text("\n* ").."Added the _server.ign to avoid uploading the UTC folder"
..WMP.important_text("\n* ").."Lua errors are now logged to the error log"
..WMP.important_text("\n* ").."Font attributes are now applied to options as well"
..WMP.important_text("\n* ").."Choosing a mainline or UMC song now adds it to the song history"
  },
  {
    name = "4.5.5",
    text = WMP.important_text("* ").."Removed song history size limit"
..WMP.important_text("\n* ").."All icons are now configurable, including per playlist"
..WMP.important_text("\n* ").."The options to change the playlist left and right images are now generated via wesnoth.have_file()/wesnoth.read_file()"
  },
  {
    name = "4.5.7",
    text = WMP.important_text("* ").."Removed translating predefined file names in mainline and UMC with nicer names"
..WMP.important_text("\n* ").."Generate lists of mainline/UMC songs with LIST_FILES"
..WMP.important_text("\n* ").."Significantly reduce WML cache size"
..WMP.important_text("\n* ").."Fixed icons not showing when choosing a playlist to play on loading"
..WMP.important_text("\n* ").."Fixed the icon setting options being prefixed with 'icons/'"
  },
  {
    name = "4.5.9",
    text = WMP.important_text("* ").."Moved the right click menu creation into the initialization preload event"
..WMP.important_text("\n* ").."Uploaded the Wesnoth Music Player Extras add-on"
..WMP.important_text("\n* ").."Fixed the list of music available in add-ons getting duplicated each reload"
  },
  {
    name = "4.6.0",
    text = WMP.important_text("* ").."Changed removed wml.variable.get()/.set() lua calls to wml.variables[var]"
..WMP.important_text("\n* ").."Changed removed wml.variable.set_array()/.get_array() lua calls to wml.array_access.set()/.get()"
..WMP.important_text("\n* ").."Various bug fixes when starting with no persistent data"
..WMP.important_text("\n* ").."Updated name of UMC Music Books, so they are sorted correctly on the add-ons server"
  },
  {
    name = "4.6.5",
    text = WMP.important_text("* ").."Removed a missed debugging message"
..WMP.important_text("\n* ").."Removed the DEFAULT argument from OPTION_ATTRIBUTES and HELP_OPTION_ATTRIBUTES"
..WMP.important_text("\n* ").."Re-implemented HELP_OPTION_ATTRIBUTES as an optional argument to OPTION_ATTRIBUTES"
..WMP.important_text("\n* ").."Made use of DEFAULT_MUSIC_PLAYLIST_NO_EVENT/FULL_MUSIC_PLAYLIST_NO_EVENT instead"
..WMP.important_text("\n* ").."Fixed Wesnoth Songs not showing any options"
..WMP.important_text("\n* ").."Fixed lists of UMC songs not appearing after previously being set to hidden"
..WMP.important_text("\n* ").."Made the default HELP_COLOR more visible"
..WMP.important_text("\n* ").."Fixed selecting nothing in the portrait options instead going into a previously chosen race option"
..WMP.important_text("\n* ").."Added support for the RC and CHAN IPFs"
  },
  {
    name = "4.7.0",
    text = WMP.important_text("* ").."Implemented and used to [titled_music] wrapper tag around [music]"
..WMP.important_text("\n* ").."Implmented [dictionary] and DICT_GET/DICT_SET"
..WMP.important_text("\n* ").."Renamed WesnothMusicPlayer global lua table to WMP"
  },
  {
    name = "4.8.0",
    text = WMP.important_text("* ").."Removed Help functionality"
..WMP.important_text("\n* ").."Removed IPF functionality"
..WMP.important_text("\n* ").."Removed temporary playlist functionality"
..WMP.important_text("\n* ").."Removed ability to change song history and playlist sorting criteria"
..WMP.important_text("\n* ").."Removed ability to change font attributes"
..WMP.important_text("\n* ").."Removed ability to change text color"
..WMP.important_text("\n* ").."Removed ability to change icons"
..WMP.important_text("\n* ").."Removed ability to disable verification that a song exists"
..WMP.important_text("\n* ").."Removed ability to choose the portraits displayed"
..WMP.important_text("\n* ").."Removed the lists of songs from the UMC music add-ons"
..WMP.important_text("\n* ").."Removed the Reset Everything option"
..WMP.important_text("\n* ").."Removed the ability to hide/unhide the UMC music add-ons"
..WMP.important_text("\n* ").."The above removals reduce cache size by almost 75%"
..WMP.important_text("\n* ").."Reverted back to using [music] rather than [titled_music]"
..WMP.important_text("\n* ").."Fixed variable leak of MusicTemp.play due to a typo"
..WMP.important_text("\n* ").."Lua-ified the author information section"
  },
  {
    name = "5.0.0",
    text = WMP.important_text("* ").."Removed upgrade.cfg logic"
..WMP.important_text("\n* ").."Removed most features"
..WMP.important_text("\n* ").."Removed most of MusicPersist"
..WMP.important_text("\n* ").."Converted as much as possible of what remains to use lua/GUI2"
  },
  {
    name = "5.0.5",
    text = WMP.important_text("* ").."The current playlist name is now displayed"
..WMP.important_text("\n* ").."Removed the .ogg extension from being displayed at the end of song names"
..WMP.important_text("\n* ").."Fixed the green ball icon not having a line of transparent pixels on its right and bottom borders"
..WMP.important_text("\n* ").."Combined the Play a Playlist and Play a Song dialogs"
..WMP.important_text("\n* ").."Combined the Changelog and Authors dialogs"
  },
}
