function WMP.info_preshow()
------
-- Local functions
------
  local function select_umc()
    wesnoth.set_dialog_value(WMP.umc[wesnoth.get_dialog_value("info_list")].text, "info_text")
  end
  
  local function set_umc_on_ui()
    for i=1,#WMP.umc do
      wesnoth.set_dialog_value(WMP.option_icon, "info_list", i, "option_icon")
      wesnoth.set_dialog_value(WMP.umc[i].name, "info_list", i, "option_text")
    end
    
    wesnoth.set_dialog_callback(select_umc, "info_list")
    select_umc()
  end
  
  local function select_changelog()
    wesnoth.set_dialog_value(WMP.changelogs[wesnoth.get_dialog_value("info_list")].text, "info_text")
  end
  
  local function set_changelogs_on_ui()
    for i=1,#WMP.changelogs do
      wesnoth.set_dialog_value(WMP.option_icon, "info_list", i, "option_icon")
      wesnoth.set_dialog_value(WMP.changelogs[i].name, "info_list", i, "option_text")
    end
    
    wesnoth.set_dialog_callback(select_changelog, "info_list")
    select_changelog()
  end
  
------
-- Initialization logic
------
  WMP.is_umc = true
  wesnoth.set_dialog_value(WMP.portrait_left, "left_image")
  wesnoth.set_dialog_value(WMP.portrait_right, "right_image")
  
  set_umc_on_ui()
  
------
-- Button click functions
------
  local function info_umc_changelog()
    if WMP.is_umc then
      WMP.is_umc = false
      wesnoth.remove_dialog_item(1, #WMP.umc, "info_list")
      
      wesnoth.set_dialog_value("UMC", "info_umc_changelog")
      set_changelogs_on_ui()
    else
      WMP.is_umc = true
      wesnoth.remove_dialog_item(1, #WMP.changelogs, "info_list")
      
      wesnoth.set_dialog_value("Changelogs", "info_umc_changelog")
      set_umc_on_ui()
    end
  end
  
  wesnoth.set_dialog_callback(info_umc_changelog, "info_umc_changelog")
end

function WMP.info_postshow()
  
end
